package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/db/model"
	zhios_condition_statistics_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/utils"
	zhios_condition_statistics_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_condition_statistics.git/utils/logx"
	"fmt"
	"xorm.io/xorm"
)

func MallOrdByTimeWithCount(Db *xorm.Engine, uid, buyType, state, stime, etime interface{}) (int64, error) {
	total, err := Db.Where("uid = ?   AND confirm_time > ? AND confirm_time < ?", uid, stime, etime).In("state", state).Count(&model.MallOrd{})
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}

// 查询用户某时间段内某状态的佣金(ord_id => amount)
func MallOrderRelateListByTimeByState(Db *xorm.Engine, uid, state, startTime, endTime interface{}) (*map[int64]float64, float64, error) {
	var o []*model.MallOrd
	var or []*model.MallOrdListRelate
	var idAmountMap = make(map[int64]float64)
	// 分佣明细数据
	err := Db.Where("`uid` = ?", uid).Find(&or)
	if err != nil {
		zhios_condition_statistics_logx.Error(err)
		return nil, 0, err
	}
	if len(or) == 0 {
		return &idAmountMap, 0, nil
	}
	var ids []int64
	for _, item := range or {
		ids = append(ids, item.Oid)
	}
	str := fmt.Sprintf("state in (%s) AND create_time >%s AND create_time < %s", state, startTime, endTime)
	fmt.Println("============test佣金数=================")
	fmt.Println(str)
	// 已结算的订单数据
	err = Db.In("ord_id", ids).Where("state in (?) AND confirm_time > ? AND confirm_time < ?", state, startTime, endTime).Find(&o)
	if err != nil {
		zhios_condition_statistics_logx.Error(err)
		return nil, 0, err
	}
	if len(o) == 0 {
		return &idAmountMap, 0, nil
	}

	// id => amount
	for _, item := range o {
		for _, i := range or {
			if item.OrdId == i.Oid {
				idAmountMap[i.Oid] = i.Amount
			}
		}
	}
	var sum float64
	for _, item := range idAmountMap {
		sum += item
	}
	return &idAmountMap, sum, nil
}

func MallOrdByTime(Db *xorm.Engine, uid, buyType, state, stime, etime interface{}, newState string) (float64, error) {
	sess := Db.Where("uid = ?  ", uid).In("state", state)
	if newState == "1" {
		sess = sess.And(" create_time > ? AND create_time < ?", stime, etime)
	} else {
		sess = sess.And(" confirm_time > ? AND confirm_time < ?", stime, etime)
	}
	if zhios_condition_statistics_utils.AnyToInt64(buyType) > 0 {
		sess.And("order_type=?", buyType)
	}
	total, err := sess.Sum(&model.MallOrd{}, "cost_price")
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}

func MallOrdWithCount(Db *xorm.Engine, uid, buyType, state interface{}) (int64, error) {
	total, err := Db.Where("uid = ?  ", uid).In("state", state).Count(&model.MallOrd{})
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}

// 查询用户某时间段内某状态的佣金(ord_id => amount)
func MallOrderRelateListByState(Db *xorm.Engine, uid, state interface{}) (*map[int64]float64, float64, error) {
	var o []*model.MallOrd
	var or []*model.MallOrdListRelate
	var idAmountMap = make(map[int64]float64)
	// 分佣明细数据
	err := Db.Where("`uid` = ?", uid).Find(&or)
	if err != nil {
		zhios_condition_statistics_logx.Error(err)
		return nil, 0, err
	}
	if len(or) == 0 {
		return &idAmountMap, 0, nil
	}
	var ids []int64
	for _, item := range or {
		ids = append(ids, item.Oid)
	}
	str := fmt.Sprintf("state in (%s) ", state)
	fmt.Println("============test佣金数=================")
	fmt.Println(str)
	// 已结算的订单数据
	err = Db.In("ord_id", ids).Where("state in (?) ", state).Find(&o)
	if err != nil {
		zhios_condition_statistics_logx.Error(err)
		return nil, 0, err
	}
	if len(o) == 0 {
		return &idAmountMap, 0, nil
	}

	// id => amount
	for _, item := range o {
		for _, i := range or {
			if item.OrdId == i.Oid {
				idAmountMap[i.Oid] = i.Amount
			}
		}
	}
	var sum float64
	for _, item := range idAmountMap {
		sum += item
	}
	return &idAmountMap, sum, nil
}

func MallOrd(Db *xorm.Engine, uid, buyType, state interface{}) (float64, error) {
	sess := Db.Where("uid = ?  ", uid).In("state", state)
	if zhios_condition_statistics_utils.AnyToInt64(buyType) > 0 {
		sess.And("order_type=?", buyType)
	}
	total, err := sess.Sum(&model.MallOrd{}, "cost_price")
	fmt.Println(err)
	fmt.Println(total)
	if err != nil {
		return 0, zhios_condition_statistics_logx.Error(err)
	}
	return total, nil
}
