package model

import (
	"time"
)

type UserLevelChangeLog struct {
	Id                  int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Uid                 int       `json:"uid" xorm:"default 0 comment('用户id') INT(11)"`
	BeforeLv            int       `json:"before_lv" xorm:"default 0 comment('更改前的等级') INT(11)"`
	AfterLv             int       `json:"after_lv" xorm:"default 0 comment('更改后的等级') INT(11)"`
	Time                int       `json:"time" xorm:"INT(11)"`
	BeforeLevelExpireAt time.Time `json:"before_level_expire_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新前过期时间') TIMESTAMP"`
	AfterLevelExpireAt  time.Time `json:"after_level_expire_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新后过期时间') TIMESTAMP"`
	Type                string    `json:"type" xorm:"default '' comment('类型') VARCHAR(255)"`
	BeforeLevelArriveAt time.Time `json:"before_level_arrive_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新前到达该等级的时间') TIMESTAMP"`
	AfterLevelArriveAt  time.Time `json:"after_level_arrive_at" xorm:"default 'CURRENT_TIMESTAMP' comment('更新后到达该等级的时间') TIMESTAMP"`
}
